from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int

Polaritycalculation_V0_1_0 = CommandToolBuilder(tool="PolarityCalculation", base_command=["PolarityCalculation"], inputs=[ToolInput(tag="in_bam_list_file", input_type=File(optional=True), prefix="--bamListFile", doc=InputDocumentation(doc="Bam file list, containing 4 columns.Namely\nbamFiles,readLength, offSet, bamLegend. '-f' and '-i,\n-r, -s, -t' parameters are mutually\nexclusive.default=none.")), ToolInput(tag="in_input", input_type=File(optional=True), prefix="--input", doc=InputDocumentation(doc="Input file(s) in bam format. All files should be split\nby comma e.g. 1.bam,2.bam,3.bam[required]")), ToolInput(tag="in_coordinate_file", input_type=File(optional=True), prefix="--coordinateFile", doc=InputDocumentation(doc="The file should contain the coordinate of start and\nstop codon. Generated by\nOutputTranscriptInfo.py.[required]")), ToolInput(tag="in_ot_put_prefix", input_type=String(optional=True), prefix="--otput_prefix", doc=InputDocumentation(doc="Prefix of output files.[required]")), ToolInput(tag="in_specific_reads_length", input_type=Int(optional=True), prefix="--specific_reads_length", doc=InputDocumentation(doc="Specific the lenght to do analysis, comma split. e.g.\n'28,29,30'.If use all length set 'All'. Bam files diff\nlength select split by '_' e.g. '28,29,30_ALL_27,28'\n[required]")), ToolInput(tag="in_offset", input_type=Int(optional=True), prefix="--offset", doc=InputDocumentation(doc="Specific the offset corresponding to read length,\ncomma split. e.g. '12,13,13'. No offset set 0. Bam\nfiles diff offset select split by '_' e.g.\n'12,13,13_0_12,12' [required]")), ToolInput(tag="in_bam_file_legend", input_type=File(optional=True), prefix="--bam_file_legend", doc=InputDocumentation(doc="The legend of each bam files, comma split. e.g.\n'condition1,condition2,condition3' [required]")), ToolInput(tag="in_select_trans_list", input_type=String(optional=True), prefix="--select_trans_list", doc=InputDocumentation(doc="Selected transcript list used for metagene\nanalysis.This files requires the first column must be\nthe transcript ID  with a column name.")), ToolInput(tag="in_minimum_cds_counts", input_type=Int(optional=True), prefix="--minimum_cds_counts", doc=InputDocumentation(doc="Minimum CDS counts. CDS counts smaller than\n'min_cds_counts' will be skipped. default=64")), ToolInput(tag="in_id_type", input_type=String(optional=True), prefix="--id-type", doc=InputDocumentation(doc="define the id type users input. the default is\ntranscript id, if not, will be transformed into\ntranscript id. transcript_id=default")), ToolInput(tag="in_plot", input_type=String(optional=True), prefix="--plot", doc=InputDocumentation(doc="Output a polarity plot or not.default=yes"))], outputs=[], container="quay.io/biocontainers/ribominer:0.2.3.1--pyh3252c3a_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Polaritycalculation_V0_1_0().translate("wdl")

